Allowing Experimental Error Codes in the Path Computation Element Protocol
Adrian Farrel
Old Dog Consulting
adrian@olddog.co.uk
Haomian Zheng
Huawei Technologies
zhenghaomian@huawei.com
2024
PCE Working Group
Experimental RFCs are often considered beneficial approaches to developing new protocol features. To that end, sub-ranges of code point registries are often designated as for experimental use.
IANA assigns values to the Path Computation Element Communication Protocol (PCEP) parameters (messages, objects, TLVs). According to RFC 5440 as updated by RFC 8356, the allocation policies for the registries for PCEP messages, objects, and TLV types are IETF Review with some sub-ranges of these registries being assigned for Experimental Use. However, the registry of PCEP Error-Types and Error-values has only the IETF Review assignment policy meaning that experimentation is somewhat limited.
This document updates RFC 5440 by designating a range of PCEP Error-Types for Experimental Use.
Introduction
The Path Computation Element Communication Protocol (PCEP) [RFC5440] provides mechanisms for Path Computation Elements (PCEs) to perform path computations in response to Path Computation Client (PCC) requests, or autonomously in the case of stateful PCEs [RFC8281]. The computed paths are used when provisioning connectivity through Traffic Engineered networks.
In Section 9 of [RFC5440], IANA assigns values to the PCEP parameters. The allocation policy for each of these parameters specified in RFC 5440 is IETF Review [RFC8126].
In consideration of the benefits of making experiments with PCEP and the utility of experimental codepoints [RFC3692], codepoint ranges for PCEP messages, objects, and TLV types for Experimental Use [RFC8126] are designated in [RFC8356].
However, protocol experiments may also need to return protocol error messages indicating experiment-specific error cases. It will often be the case that previously assigned error codes (in the PCEP-ERROR Object Error Types and Values sub-registry) can be used to indicate the error cases within an experiment, but there may also be cases where new, experimental error codes are needed.
In order to run experiments, it is important that the codepoint values used in the experiments do not collide with existing codepoints or any future allocations.
This document updates [RFC5440] by changing the allocation policy for the registry of PCEP Error-Types to mark some of the codepoints as assigned for Experimental Use. As stated in [RFC3692], experiments using these codepoints are not intended to be used in general deployments, and due care must be taken to ensure that two experiments using the same codepoints are not run in the same environment.
Consideration of RFC 8356
It is worth noting that [RFC8356] deliberately chose to make experimental codepoints available only in the PCEP messages, objects, and TLV types registries. Appendix A of that document gives a brief explanation of why that decision was taken stating that, "The justification for this decision is that, if an experiment finds that it wants to use a new codepoint in another PCEP sub-registry, it can implement the same function using a new experimental object or TLV instead."
While it is true that an experimental implementation could assign an experimental PCEP object and designate it the "experimental errors object", using it to carry arbitrary contents including experimental error codes, such an approach would cause unnecessary divergence in the code. The allowance of experimental Error-Types is a better approach that will more easily enable migration of successful experiments onto the Standards Track.
Experimental Error-Types
This document allows for the designation of four PCEP Error-Type codepoints (252-255) for Experimental Use.
Section 5 provides the IANA considerations for this designation. Section 3 gives advice about how to construct an experiment using these codepoints.
Advice on Experimentation
An experiment that wishes to return experimental error codes should use one of the experimental Error-Type values as defined in this document. The experiment should agree, between all participating parties, which Error-Type to use and which Error-values to use within that Error-Type. The experiment will describe what the meanings of those Error-Type / Error-value pairs are. Those Error-Type and Error-values should not be recorded in any public (especially any IETF) documentation. Textual or symbolic names for the Error-Types and Error-values may be used to help keep the documentation clear.
If multiple experiments are taking place at the same time using the same implementations, care must be taken to keep the sets of Error-Type / Error-value distinct.
Note that there is no scope for experimental Error-values within existing non-experimental Error-Types. This reduces the complexity of the registry and of implementations. Experiments should place all experimental Error-values under the chosen experimental Error-Types.
If, at some future time, the experiment is declared a success and moved to IETF work targeting publication on the Standards Track, each pair of Error-Type / Error-value will need to be assigned by IANA from the registry. In some cases, this will involve assigning a new Error-Type with its subtended Error-values. In other case, use may be made of an existing Error-Type with new subtended Error-values being assigned. The resulting change to code in an implementation is as simple as changing the numeric values of the Error-Types and Error-values.
Handling of Unknown Experimentation
A PCEP implementation that receives an experimental Error-Type in a PCEP message and does not recognise the Error-Type (i.e., is not part of the experiment) will treat the error as it would treat any other unknown Error-Type (such as from a new protocol extension). An implementation that is notified of a PCEP error will normally close the PCEP session (see [RFC5440]). In general, PCEP implementations are not required to take specific action based on Error-Types, but may log the errors for diagnostic purposes.
An implementation that is part of an experiment may receive an experimental Error-Type, but not recognise the Error-value. This could happen because of any of:
- A faulty implementation.
- Two implementations not being synchronised with respect to which Error-values to use in the experiment.
- More than one experiment being run at the same time.
As with unknown Error-Types, an implementation receiving an unknown Error-value is not expected to do more than log the received error, and may close the PCEP session.
IANA Considerations
IANA maintains a registry called "Path Computation Element Protocol (PCEP) Numbers" with a sub-registry named "PCEP-ERROR Object Error Types and Values". IANA is requested to change the assignment policy for this sub-registry to read:
- Error-Types
  - 0-251 : IETF Review
  - 252-255 : Experimental Use
- Error-value
  - For all IETF Review Error-Types : IETF Review
  - For all Experimental Use Error-Types : Experimental Use
Additionally, IANA is requested to make an entry in the table as follows:

Error-Type | Meaning            | Error-value            | Reference
-----------+--------------------+------------------------+-----------
252-255    | Experimental Use   | 0-255 Experimental Use | [this.I-D]
           | Not to be assigned | Not to be assigned     |

Security Considerations
This document does not introduce any new security considerations to the existing protocol. Refer to [RFC5440] and [I-D.ietf-pce-pceps-tls13] for further details of the specific security measures applicable to PCEP.
[RFC3692] asserts that the existence of experimental codepoints introduces no new security considerations. However, implementations accepting experimental error codepoints need to take care in how they parse and process them in case they come, accidentally, from another experiment. Further, an implementation accepting experimental codepoints needs to consider the security aspects of the experimental extensions. [RFC6709] provides various design considerations for protocol extensions (including those designated as experimental).
Manageability Considerations
The main manageability impacts of this work are as follows:
- Implementations participating in any experiment should be made such that the Error-Type and Error-value numbers can be easily changed. This will enable quick modification if there are any collisions with other experiments.
- All implementations that receive and report Error-Types and Error-values (including protocol analysers) should report numeric values and state "unknown" if they do not know a specific interpretation of an error. This is not a new requirement or behavior, but is called out here as it is important for this case.
Acknowledgements
Thanks to Dhruv Dhody for discussions that led to the creation of this document.

Normative References

Informative References
[RFC5440]
[RFC8126]
[RFC3692]
[RFC8356]
[I-D.ietf-pce-pceps-tls13]
[RFC6709]